/*
* Copyright 2020 Kumori systems S.L.
*
* Licensed under the EUPL, Version 1.2 or – as soon they
* will be approved by the European Commission - subsequent
* versions of the EUPL (the "Licence");
* You may not use this work except in compliance with the
* Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl
*
* Unless required by applicable law or agreed to in
* writing, software distributed under the Licence is
* distributed on an "AS IS" basis,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing
* permissions and limitations under the Licence.
 */
// Code generated by lister-gen. DO NOT EDIT.

package v1beta1

import (
	v1beta1 "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/apis_openstack/openstack/v1beta1"
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// OpenStackMachineLister helps list OpenStackMachines.
// All objects returned here must be treated as read-only.
type OpenStackMachineLister interface {
	// List lists all OpenStackMachines in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1beta1.OpenStackMachine, err error)
	// OpenStackMachines returns an object that can list and get OpenStackMachines.
	OpenStackMachines(namespace string) OpenStackMachineNamespaceLister
	OpenStackMachineListerExpansion
}

// openStackMachineLister implements the OpenStackMachineLister interface.
type openStackMachineLister struct {
	indexer cache.Indexer
}

// NewOpenStackMachineLister returns a new OpenStackMachineLister.
func NewOpenStackMachineLister(indexer cache.Indexer) OpenStackMachineLister {
	return &openStackMachineLister{indexer: indexer}
}

// List lists all OpenStackMachines in the indexer.
func (s *openStackMachineLister) List(selector labels.Selector) (ret []*v1beta1.OpenStackMachine, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1beta1.OpenStackMachine))
	})
	return ret, err
}

// OpenStackMachines returns an object that can list and get OpenStackMachines.
func (s *openStackMachineLister) OpenStackMachines(namespace string) OpenStackMachineNamespaceLister {
	return openStackMachineNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// OpenStackMachineNamespaceLister helps list and get OpenStackMachines.
// All objects returned here must be treated as read-only.
type OpenStackMachineNamespaceLister interface {
	// List lists all OpenStackMachines in the indexer for a given namespace.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1beta1.OpenStackMachine, err error)
	// Get retrieves the OpenStackMachine from the indexer for a given namespace and name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v1beta1.OpenStackMachine, error)
	OpenStackMachineNamespaceListerExpansion
}

// openStackMachineNamespaceLister implements the OpenStackMachineNamespaceLister
// interface.
type openStackMachineNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all OpenStackMachines in the indexer for a given namespace.
func (s openStackMachineNamespaceLister) List(selector labels.Selector) (ret []*v1beta1.OpenStackMachine, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v1beta1.OpenStackMachine))
	})
	return ret, err
}

// Get retrieves the OpenStackMachine from the indexer for a given namespace and name.
func (s openStackMachineNamespaceLister) Get(name string) (*v1beta1.OpenStackMachine, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1beta1.Resource("openstackmachine"), name)
	}
	return obj.(*v1beta1.OpenStackMachine), nil
}
